From 56d8748e994c0c768a4c3808ffab109997255ecb Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Tue, 13 Aug 2019 12:52:43 -0400
Subject: [PATCH 17/31] modified squad user initialization messages to better
 focus on specific steps of the process; dealt with different methods of
 communicating squad information to users, though not yet ready to implement
 the switchboard protocol

---
 .../game/SquadDefinitionActionMessage.scala   |  24 +-
 .../scala/services/teamwork/SquadAction.scala |   3 +-
 .../services/teamwork/SquadResponse.scala     |   4 +-
 .../services/teamwork/SquadService.scala      | 399 ++++++++++++++----
 .../src/main/scala/WorldSessionActor.scala    |  11 +-
 5 files changed, 356 insertions(+), 85 deletions(-)

diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 11a56ee2..6fd99e69 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -35,7 +35,7 @@ object SquadAction{
     * Dispatched from client to server to indicate a squad detail update that has no foundation entry to update?
     * Not dissimilar from `DisplaySquad`.
     */
-  final case class DisplayFullSquad() extends SquadAction(1)
+  final case class SquadMemberInitializationIssue() extends SquadAction(1)
 
   final case class SaveSquadFavorite() extends SquadAction(3)
 
@@ -53,6 +53,8 @@ object SquadAction{
 
   final case class CancelSelectRoleForYourself(value: Long = 0) extends SquadAction(15)
 
+  final case class AssociateWithSquad() extends SquadAction(16)
+
   final case class SetListSquad() extends SquadAction(17)
 
   final case class ChangeSquadPurpose(purpose : String) extends SquadAction(19)
@@ -110,10 +112,10 @@ object SquadAction{
       }
     )
 
-    val displayFullSquadCodec = everFailCondition.xmap[DisplayFullSquad] (
-      _ => DisplayFullSquad(),
+    val squadMemberInitializationIssueCodec = everFailCondition.xmap[SquadMemberInitializationIssue] (
+      _ => SquadMemberInitializationIssue(),
       {
-        case DisplayFullSquad() => None
+        case SquadMemberInitializationIssue() => None
       }
     )
 
@@ -173,6 +175,13 @@ object SquadAction{
       }
     )
 
+    val associateWithSquadCodec = everFailCondition.xmap[AssociateWithSquad] (
+      _ => AssociateWithSquad(),
+      {
+        case AssociateWithSquad() => None
+      }
+    )
+
     val setListSquadCodec = everFailCondition.xmap[SetListSquad] (
       _ => SetListSquad(),
       {
@@ -347,7 +356,7 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`6 ` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`8 ` - Request List Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`9 ` - Stop List Squad<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`16` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`16` - Associate with Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`17` - Set List Squad (ui)<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`18` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`26` - Reset All<br>
@@ -415,7 +424,7 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
     import scala.annotation.switch
     ((code : @switch) match {
       case 0 => displaySquadCodec
-      case 1 => displayFullSquadCodec
+      case 1 => squadMemberInitializationIssueCodec
       case 3 => saveSquadFavoriteCodec
       case 4 => loadSquadFavoriteCodec
       case 5 => deleteSquadFavoriteCodec
@@ -424,6 +433,7 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 9 => stopListSquadCodec
       case 10 => selectRoleForYourselfCodec
       case 15 => cancelSelectRoleForYourselfCodec
+      case 16 => associateWithSquadCodec
       case 17 => setListSquadCodec
       case 19 => changeSquadPurposeCodec
       case 20 => changeSquadZoneCodec
@@ -442,7 +452,7 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 40 => findLfsSoldiersForRoleCodec
       case 41 => cancelFindCodec
       case 2 | 6 | 11 |
-           12 | 13 | 14 | 16 |
+           12 | 13 | 14 |
            18 | 29 | 30 | 32 | 33 |
            36 | 37 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
diff --git a/common/src/main/scala/services/teamwork/SquadAction.scala b/common/src/main/scala/services/teamwork/SquadAction.scala
index 1677cf75..62e3f2fe 100644
--- a/common/src/main/scala/services/teamwork/SquadAction.scala
+++ b/common/src/main/scala/services/teamwork/SquadAction.scala
@@ -2,13 +2,14 @@
 package services.teamwork
 
 import net.psforever.objects.Player
+import net.psforever.objects.zones.Zone
 import net.psforever.packet.game._
 import net.psforever.types.{SquadRequestType, Vector3}
 
 object SquadAction {
   trait Action
 
-  final case class Definition(player : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
+  final case class Definition(player : Player, zone : Zone, guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
   final case class Membership(request_type : SquadRequestType.Value, unk2 : Long, unk3 : Option[Long], player_name : String, unk5 : Option[Option[String]]) extends Action
   final case class Update(char_id : Long, health : Int, max_health : Int, armor : Int, max_armor : Int, pos : Vector3, zone_number : Int) extends Action
 }
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index 562082ae..fa06d866 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -14,8 +14,10 @@ object SquadResponse {
   final case class UpdateList(infos : Iterable[(Int, SquadInfo)]) extends Response
   final case class RemoveFromList(infos : Iterable[Int]) extends Response
 
-  final case class InitSquad(squad_guid : PlanetSideGUID) extends Response
+  final case class AssociateWithSquad(squad_guid : PlanetSideGUID) extends Response
+  final case class SetListSquad(squad_guid : PlanetSideGUID) extends Response
   final case class Unknown17(squad : Squad, char_id : Long) extends Response
+
   final case class Membership(request_type : SquadResponseType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
   final case class Invite(from_char_id : Long, to_char_id : Long, name : String) extends Response
   final case class WantsSquadPosition(bid_name : String) extends Response
